class Head{// extends FacialFeature{
  //Dependent Values
  float maxSize;
  
  //Dynamic Values
  float hHeight;
  float hBotWidth, hMidWidth, hTopWidth;
  float topx,topy,botx,boty;
  
  color strokeColor, fillColor;
  
  int drawMode = 0;
  int CIRCLE = 0;
  int CURVE = 1;
  
  Head(color strokeColor, color fillColor, float maxSize){
    this.strokeColor = strokeColor;
    this.fillColor = fillColor;
    this.maxSize = maxSize;
    
    drawMode = int(random(0,2));
    //drawMode = 1;
  }
  
  void draw(){
    stroke(strokeColor);
    fill(fillColor);
    
    if (drawMode == CIRCLE){
      ellipse(0, 0, hTopWidth, hHeight);
    } else {

      float midX = 0;
      float midY = 0;
      
      fill(255);
      beginShape();
      curveVertex(-botx, boty); //O
      curveVertex(-topx,- topy); //B
      curveVertex(topx, - topy); //R
      curveVertex(botx, + boty); //G
      curveVertex(-botx, + boty); //O
      curveVertex(-topx, -topy); //B
      curveVertex(topx,-topy); //R
      endShape(CLOSE);
      
      //DEBUG
     /* 
      rectMode(CENTER);
      fill(0,0,255);//B
      rect(-topx, -topy, 10,10);
      fill(255,00,00); //R
      rect(topx,-topy, 10,10);
      
      fill(255,127,00); //O
      rect(-botx, boty, 10,10);
      fill(00,255,00); //G
      rect(botx,  boty, 10,10);
      */
    }
  }
  
  void generateValues(){
   //HEAD

   if (drawMode == CIRCLE){
      hTopWidth = random(40, maxSize);
      hBotWidth = hTopWidth;
      hMidWidth = hTopWidth;
      hHeight = random(40, maxSize);
    } else {
      topx = random(30, maxSize/2);
      topy = random(50, maxSize/2);
      botx = random(30, maxSize/2);
      boty = random(50, maxSize/2);
      
      float xDiff = abs(botx-topx)/2;
      //hWidth = topx>botx ? topx-xDiff : botx-xDiff;
      hTopWidth = topx*2;
      hMidWidth = topx>botx ? topx-xDiff : botx-xDiff;
      hBotWidth = botx*2;
      hHeight = topy+boty;
    }
    
   // println("Height: " + hHeight);
  }
  
   String toString(){
    return hTopWidth+","+hMidWidth+","+hBotWidth+","+hHeight;
  }
  
 float getTopWidth(){
  return hTopWidth; 
 }
 
 float getWidth(){
  return hMidWidth; 
 }
 
 float getBotWidth(){
  return hBotWidth;  
 }
 
 float getHeight(){
  return hHeight; 
 }
  
}
