class EyeBrows{// extends FacialFeature{
  
  //Dependent Values
  float eyeY, eyeHeight, eyeLeftX, eyeRightX;
  float eBrowY;
  float sizeFactor;
  
  //Dynamic Values
  float eBrowLength, eBrowMid, eBrowStartY, eBrowMidY, eBrowEndY;
  
  color strokeColor, fillColor;
  
  //External Values
  Eye e;
  
  EyeBrows(Eye eye, color strokeColor, color fillColor, float sizeFactor){
    e = eye;
    
    this.strokeColor = strokeColor;
    this.fillColor = fillColor;
    this.sizeFactor = sizeFactor;
  }
  
  //EYEBROWS
  void generateValues(){
   //Dependent values
   eyeY = e.getEyeY();
   eyeHeight = e.getEyeHeight();
   eyeLeftX = e.getLeftX();
   eyeRightX = e.getRightX();
   eBrowY = e.getEyeY() - (e.getEyeHeight()/2); //eY - eHeight/2;
   
   //Dynamic Values
   eBrowLength = random(10,30);//20;
   eBrowMid = random(0,eBrowLength);//17; //zero to eBrowLength
   eBrowStartY = random(-5,5);//0;
   eBrowMidY = random(-7,7);//7;
   eBrowEndY = random(-5,5);//2; 
  }
  
  String toString(){
    return eBrowLength+","+eBrowMid+","+eBrowStartY+","+eBrowMidY+","+eBrowEndY;
  }
  
   void draw(){
     
     stroke(strokeColor);
     noFill();
     
     float LX1 = eyeLeftX-(eBrowLength/2);
     float LY1 = eBrowY + eBrowStartY;
     float LX2 = LX1+eBrowMid;
     float LY2 = eBrowY + eBrowMidY;
     float LX3 = LX1+eBrowLength;
     float LY3 = eBrowY+eBrowEndY;
     drawBrowHelper(LX1, LY1, LX2, LY2, LX3, LY3);
     
     float RX1 = eyeRightX+(eBrowLength/2); //starts at the far right
     float RY1 = eBrowY + eBrowStartY;
     float RX2 = RX1-eBrowMid;
     float RY2 = eBrowY + eBrowMidY;
     float RX3 = RX1-eBrowLength;
     float RY3 = eBrowY+eBrowEndY;
     drawBrowHelper(RX1, RY1, RX2, RY2, RX3, RY3);
  } 
  
  void drawBrowHelper(float x1,float y1,float x2,float y2,float x3,float y3){
    line(x1, y1, x2, y2);
    line(x2, y2, x3, y3);
  }
}
