Face f;
AI ai = new AI();
int containerSize = 200;
PFont font;



void setup(){
 size(400,400); 
 background(150);
 smooth();
 makeFaces();
 
 font = createFont("Helvetica", 24);
 makeResetButton();
}

void draw(){
  makeResetButton();
  f.drawFace();
}

void makeFaces(){
   f = new Face((width/2),(height/2), containerSize);
   f.randomizeFace();
   f.drawFace();
}
/*
void mousePressed()
{
  boolean t = false;
  background(150);
  for (int i = 0; i < faces.size(); i++){
     Face f = (Face)faces.get(i);
     boolean clicked = f.isClicked(mouseX,mouseY,containerSize); 
     
     if (clicked){
       f.drawFace();
       //add this face to the AI
       t = true;
       ai.inputSelectedFeatures(f.getFaceStuff());
       //f.printFace();
       float rand = random(200, 99999);
       saveToJPG("Face"+rand+".jpg", f.getX()-(containerSize/2), f.getY()-(containerSize/2), containerSize);
       println(f.getX() + "/" + f.getY());
     }
  }
  
  if (!t){
    makeFaces();
  }
}
*/
/*
void mousePressed(){
 background(150);
 makeFaces(); 
 f.toString();
 makeResetButton();
}
*/

String jsGetFace(){
  return f.toString();
}

void jsFaceSuccess(boolean success){
  resetDisplay();
}

void clearAll(){
  background(150);
}

void resetDisplay(){
   background(150);
   f = null;
   makeFaces(); 
   makeResetButton();
}

boolean overReset(){
 return mouseX > 5 && mouseX < 130 && mouseY > height-45 && mouseY <height-5;
}

void mouseReleased(){
   if (overReset()){
     resetDisplay();
     f.toString(); //for debug
   } 
}

void makeResetButton(){
 if (overReset()){
   fill(152,228,255);
   if (mousePressed){
      fill(107,161,180);
   }
 } else{
   fill(255);
 }
  
  stroke(0);
  rect(5, height-45, 130, 40);
  
  fill(0);
  textFont(font, 24); 
  text("Reset Face", 9, height-18);
}
