class Eye{// extends FacialFeature{
  //Dependent Values
  float hWidth;
  float hHeight;
  
  //random values
  float eHeight, eWidth;
  //Dynamic Values
  float eLeftX, eRightX, eY; //size
  float eSpace; //spacing between eyes
  
  color strokeColor, fillColor;
  
  Eye(Head h, color strokeColor, color fillColor, float sizeFactor){
    hWidth = h.getWidth();
    hHeight = h.getHeight();
    
    this.strokeColor = strokeColor;
    this.fillColor = fillColor;
  }
  
  void generateValues(){
   //Dynamic Values
   eHeight = random(5,25);//15
   eWidth = random(5,25);//15
   eSpace = hWidth/3;
   eLeftX = (hWidth - eSpace)/2;
   eRightX = eLeftX+eSpace;
   eY = hHeight*(.25);
  }  
  
  String toString(){
   return eHeight+","+eWidth;
  }
  
  void draw(){
    stroke(strokeColor);
    fill(fillColor);
    
    //draw left eye
    ellipseMode(CENTER);
    ellipse(eLeftX, eY, eHeight, eWidth);
    //draw right eye
    ellipse(eRightX, eY, eHeight, eWidth);
  }

  float getEyeY(){
     return eY; 
  }
  
  float getBotY(){
     return eY +eHeight/2; 
  }
  
  float getEyeHeight(){
    return eHeight;
  }
  
  float getRightX(){
   return eRightX; 
  }
  
  float getLeftX(){
   return eLeftX; 
  }
}
